{ Civilization Map Changer Version 1.0 (5/23/93)
  written by Holger Eichmann

  Changes the interrupts $f1 and $f2. If you insert a call of these
  interrupts into the right places of the civ.exe file (see writeln text
  in the main program), you are able to change important attributes of
  single points of the map while playing civ.exe. Because civ.exe has no
  list of improvements of map points (like coal, oasis or fish), but only
  calculate these points, this program generates its own list. Consider
  that this list will not be saved automatically, too, when you save your
  game. While playing you will get the cheat menu when you right click
  a distant field like normally getting informations of the landscape type
  of this field.
  In this version the program works together with (my) version 1 and
  version 5 (which you get from wuarchive.wustl.edu at 5/15/93) of civ.exe.

  Please send your comments to:
     Holger.Eichmann@cdc2.atomare-prozesse.physik.uni-hannover.dbp.de}


{$M $800,0,0}

uses dos, crt;

const maxlist = 200; { max. length of improvement list (contains the
                       coordinates of the fields with changed improvement
                       like coal or horses) }

{$F+}

var counter,i, version : word;
    x, y : array[1..maxlist] of word;

{$L c:\tp\programs\asm\civext.obj}

procedure civext(version : word; var row, column, code : word); external;

{$L c:\tp\programs\asm\civint.obj}

procedure civint; external;

procedure editor; interrupt;

var key : char;
    regs : registers;
    mode, landtype, sm_map, attr, dark, all_dark : byte;
    norm_impr, improve, exist, ende : boolean;
    row, column, code, segm, segm_dark, off_land, off_smap, off_attr1,
    off_attr2, off_dark, im_pos, i : word;
    s : array[1..25] of char;
    s1, s2, length : string[7];
    fname : string;
    f : text;

begin
   { correct one the the changes of the civ.exe (mov ax,32 -> int F1) }
   inline($b8/$32/$00/$36/$89/$46/$10); {mov ax,32h; mov ss:[bp+10h],ax}
  { get coordinates of the map field and the code segment of the int F1 call}
   civext(version, row, column, code);
   { get video mode }
   regs.ah := $0f;
   intr($10, regs);
   mode := regs.al;
   { set video mode to 80*25 text }
   regs.ah := 0;
   regs.al := 03;
   intr($10, regs);
   textcolor(15);
   { calculate segment and offset addresses of the interesting data }
   if version = 1 then
      begin
         segm_dark := code + $2613;
         segm := code + $4c46;
         off_dark := column*$32 + row + $7ff8;
      end
   else
      begin
         segm_dark := code + $236f;
         segm := code + $4d31;
         off_dark := column*$32 + row + $740;
      end;
   off_land := row*$140+column;
   off_smap := off_land + $f0;
   off_attr1 := off_land + $7d00;
   off_attr2 := off_land + $7d50;
   { get the properties of the map field }
   landtype := mem[segm:off_land];   { type of landscape (ocean, ...) }
   sm_map := mem[segm:off_smap];     { appearance in small map }
   attr := mem[segm:off_attr2];      { attributes (roads,...) }
   dark := mem[segm_dark:off_dark];  { is it dark ? }
   exist := false;            { already in improvement list ? }
   ende := false;
   im_pos := 0;               { position there }
   all_dark := 0;             { all fields set dark or clear ? }
   { calculation if it normally is improved }
   if version = 1 then
       norm_impr := (((column shr 2) * $000d + (row shr 2) * $000b
                  + memw[segm_dark:$6e00]) and $000f = (column and 3) shl 2
                  + (row and 3))
   else
       norm_impr := (((column shr 2) * $000d + (row shr 2) * $000b
                  + memw[code+$26fe:$6e80]) and $000f = (column and 3) shl 2
                  + (row and 3));
   improve := norm_impr;
   { test, if it is in improvement list }
   for i := 1 to counter do
       if (x[i] = column) and (y[i] = row) then
          begin
             improve := not norm_impr;
             exist := true;
             im_pos := i
          end;
   repeat
      { some text lines will be marked by a * }
      s[1] := char(integer(landtype=1) * 10 + 32);
      s[2] := char(integer(landtype=2) * 10 + 32);
      s[3] := char(integer(landtype=3) * 10 + 32);
      s[4] := char(integer(landtype=6) * 10 + 32);
      s[5] := char(integer(landtype=7) * 10 + 32);
      s[6] := char(integer(landtype=9) * 10 + 32);
      s[7] := char(integer(landtype=10) * 10 + 32);
      s[8] := char(integer(landtype=11) * 10 + 32);
      s[9] := char(integer(landtype=12) * 10 + 32);
      s[10] := char(integer(landtype=13) * 10 + 32);
      s[11] := char(integer(landtype=14) * 10 + 32);
      s[12] := char(integer(landtype=15) * 10 + 32);
      s[13] := char(integer(sm_map=0) * 10 + 32);
      s[14] := char(integer(sm_map=1) * 10 + 32);
      s[15] := char(integer(sm_map=2) * 10 + 32);
      s[16] := char(integer(attr and 2=2) * 10 + 32);
      s[17] := char(integer(attr and 4=4) * 10 + 32);
      s[18] := char(integer(attr and 8=8) * 10 + 32);
      s[19] := char(integer(attr and 16=16) * 10 + 32);
      s[20] := char(integer(attr and 32=32) * 10 + 32);
      s[21] := char(integer(attr and 64=64) * 10 + 32);
      if dark and 8 = 8 then s1 := 'un' else s1 := '';
      if improve then s2 := 'remove' else s2 := 'create';
      str(counter,length);
      clrscr;
      writeln ('Civilization Map Changer Version 1.0      written by Holger Eichmann');
      writeln ('(C) 1993 by Sirius Cybernetics Corporation, Sirius Star System I-III');
      writeln;
      writeln ('Position: row: ',row,',  column: ', column);
      writeln;
      writeln('Landscape: ',s[1],' (0) ocean                 Attributes:  ',s[16],' (f) irrigation');
      writeln('           ',s[2],' (1) forest                             ',s[17],' (g) mines');
      writeln('           ',s[3],' (2) swamp                              ',s[18],' (h) roads');
      writeln('           ',s[4],' (3) plain                              ',s[19],' (i) railroad');
      writeln('           ',s[5],' (4) tundra                             ',s[20],' (j) fortification');
      writeln('           ',s[6],' (5) river                              ',s[21],' (k) pollution');
      writeln('           ',s[7],' (6) grassland');
      writeln('           ',s[8],' (7) jungle                 (l) make this place ',s1,'known');
      writeln('           ',s[9],' (8) hill                   (m) make whole map known');
      writeln('           ',s[10],' (9) mountain               (n) make whole map unknown');
      writeln('           ',s[11],' (a) desert');
      writeln('           ',s[12],' (b) arctic                 (o) ',s2,' improvement');
      writeln('                                        (p) clear improvement list');
      writeln('Small map: ',s[13],' (c) unknown                (q) load list');
      writeln('           ',s[14],' (d) water                  (r) save list');
      writeln('           ',s[15],' (e) land                       list length: ',length);
      writeln;
      writeln('                            (x) exit');
      key := readkey;
      { what do you want to change ? }
      case key of
          '0'     : landtype := 1;
          '1'     : landtype := 2;
          '2'     : landtype := 3;
          '3'     : landtype := 6;
          '4'     : landtype := 7;
          '5'     : landtype := 9;
          '6'     : landtype := 10;
          '7'     : landtype := 11;
          '8'     : landtype := 12;
          '9'     : landtype := 13;
        'a','A'   : landtype := 14;
        'b','B'   : landtype := 15;
        'c','C'   : sm_map := 0;
        'd','D'   : sm_map := 1;
        'e','E'   : sm_map := 2;
        'f','F'   : attr := attr xor 2;
        'g','G'   : attr := attr xor 4;
        'h','H'   : attr := attr xor 8;
        'i','I'   : attr := attr xor 16;
        'j','J'   : attr := attr xor 32;
        'k','K'   : attr := attr xor 64;
        'l','L'   : dark := dark xor 8;
        'm','M'   : begin all_dark := 1; ende := true end;
        'n','N'   : begin all_dark := 2; ende := true end;
        'o','O'   : improve := not improve;
        'p','P'   : begin counter := 0; improve := norm_impr;
                          exist := false end;
        'q','Q'   : begin
                       improve := norm_impr;
                       exist := false;
                       write ('Filename: ');
                       readln (fname);
                       {$I-}
                       assign (f, fname);
                       reset (f);
                       {$I+}
                       if ioresult <> 0 then
                           begin
                              writeln('Error by opening of file');
                              key := readkey
                           end
                       else
                          begin
                             counter := 0;
                             repeat
                                inc (counter);
                                readln(f, x[counter], y[counter]);
                             until eof(f);
                             ende := true;
                             close(f)
                          end;
                    end;
        'r','R'   : begin
                       improve := norm_impr;
                       exist := false;
                       write ('Filename: ');
                       readln (fname);
                       {$I-}
                       assign (f, fname);
                       rewrite (f);
                       {$I+}
                       if ioresult <> 0 then
                           begin
                              writeln('Error by opening of file');
                              key := readkey
                           end
                       else
                          begin
                             for i := 1 to counter do
                                writeln(f, x[i],' ',y[i]);
                             close(f)
                          end
                    end;
        'x','X'   : ende := true;
      end;
   until ende;
   { store back the field properties }
   mem[segm:off_land] := landtype;
   mem[segm:off_smap] := sm_map;
   mem[segm:off_attr1] := attr;
   mem[segm:off_attr2] := attr;
   mem[segm_dark:off_dark] := dark;
   if not exist and (improve xor norm_impr) then
   { insert new line in improvement list }
      if counter < maxlist then
         begin
            inc(counter);
            x[counter] := column;
            y[counter] := row;
         end;
   if exist and not (improve xor norm_impr) then
   { delete line in improvement list }
      begin
         for i := im_pos to counter-1 do
            begin
               x[i] := x[i+1];
               y[i] := y[i+1];
            end;
         dec(counter);
      end;
   if all_dark = 1 then
   { mark all fields as known }
      for i := 0 to 3999 do
         if version = 1 then
            mem[segm_dark:$7ff8+i] := mem [segm_dark:$7ff8+i] or 8
         else
            mem[segm_dark:$740+i] := mem [segm_dark:$740+i] or 8;
   if all_dark = 2 then
   { make all fields dark }
      for i := 0 to 3999 do
         if version = 1 then
            mem[segm_dark:$7ff8+i] := mem [segm_dark:$7ff8+i] and $F7
         else
            mem[segm_dark:$740+i] := mem [segm_dark:$740+i] and $F7;
   { reset video mode }
   regs.ah := 0;
   regs.al := mode;
   intr($10,regs)
end;

{$F-}

begin
   writeln;
   writeln ('Civilization Map Changer Version 1.0');
   writeln ('(C) Sirius Cybernetics Corporations, Sirius Star System I-III');
   writeln ('written by Holger Eichmann');
   writeln('Copying and code changing strictly allowed! No rights reserved!');
   writeln;
   writeln('To use this tool you have to change the following bytes in civ.exe:');
   writeln('E9 [54 (vers. 1) / 59 (vers. 5)] 00 B8 32 00  -> E9 54/59 00 CD F1 00');
   writeln('3B C1 75 BB B8 01 00  ->  CD F2 90 90 90 90 90');
   writeln;
   writeln('To install use the parameter /1 for version 1 resp. /5 for version 5 !');
   if paramstr(1) = '/1' then version := 1
      else if paramstr(1) = '/5' then version := 5
         else version := 0;
   if version > 0 then writeln('civ_map installed !!')
                  else writeln('no parameter found, civ_map not installed !!');
   for i := 1 to maxlist do
      begin
        x[i] := $ffff;
        y[i] := $ffff
      end;
   counter := 0;
   setintvec($f1, @editor);
   setintvec($f2, @civint);
   keep(0)
end.